#include <stdlib.h>                      //     
#include <math.h>                        //     
#include <conio.h>
#include <iostream.h>

//---------------------------------------------------------------------------

int N;                                     //  
int s;                                     //   (    )
int m;                                     //  
int d;                                     // 

int* A;                                    // 
int* B;                                    //      A

int* h;                                    // 

double* x;                                 //d-   


double KA_random()
{
  for (int j = 1; j <= s; j++)    //  A   
  {
    int S = A[j - 1] + A[j] + A[j + 1];
    if (S%2 == 0) B[j] = 0;
    else B[j] = 1;
  }

  for (int j = 1; j <= s; j++)                    //     
    A[j] = B[j];

  A[0]     = A[s];                                    //  
  A[s + 1] = A[1];

  double y = 0;
  for (int j = 1; j <= s; j++)
    y += A[j]*exp((j - 1 - s)*log(2));    //     

  return y;
}



int main(int argc, char **argv)
{
  cout<<"Please set the input variables:"<<endl<<endl;

  cout<<"Number of random points, N = ";

  cin>>N;

  cout<<endl<<"Size of a CA array, s = ";

  cin>>s;

  cout<<endl<<"Size of a histogram, m = ";

  cin>>m;

  cout<<endl<<"Dimension of the space, d = ";

  cin>>d;

  cout<<endl<<endl;

  srand((unsigned)time(0));

  A = new int[s + 2];
  B = new int[s + 1];

  h = new int[m];

  for (int k = 0; k < m; k++) h[k] = 0;

  x = new double[d];

  for (int j = 1; j <= s; j++)             //    
  {
    double r = rand()/(double)RAND_MAX;
    if (r > 0.5) A[j] = 1;
    else A[j] = 0;
  }

  A[0]     = A[s];                          //  
  A[s + 1] = A[1];

  for (int i = 0; i < N; i++)              //  N d-  
  {
    double x_max = 0;

    for (int j = 0; j < d; j++)
    {
      x[j] = KA_random();
      if (x_max < x[j]) x_max = x[j];
    }

    int k = int(m*exp(d*log(x_max)));      // ,    d-  x
    h[k]++;
  }

  double Pk = 1.0/m;                              //   k-  

  cout<<"Histogram:"<<endl;

  double Hi = 0;                                      //  -
  for (int k = 0; k < m; k++)
  {
    cout<<"h["<<k<<"] = "<<h[k]<<"   ";

    double temp = h[k] - N*Pk;
    Hi = Hi + temp*temp/(N*Pk);
  }

  cout<<endl<<endl<<endl<<"Hi    = "<<Hi<<endl;
  cout<<"Hi_cr = "<<(m + 3*sqrt(2*m))<<endl;

  delete[] A;
  delete[] B;
  delete[] h;
  delete[] x;

  getch();

  return 0;
}
